#!/usr/bin/php
<?php

/* Version 1.0 written by Ierlandfan */
/* Version 1.0 modified by DennisD */
/* Version 2.0 rewritten by FunFair */
/* 24-10-2017 */

/* 
	Changelog Version 2.2:
	- Corrected Low and Normal tariff. They were reversed.
	
	Changelog Version 2.1
	- Removed the compare to previous value, so it will update every minute.

	Changelog Version 2.0:																		
	- Rewrite from version 1.0																	
	- Define IP adresses and idx value at start													
	- Check if Toon value is lower than Domoticz Value. (In case connection is lost with meteradapter, Toon will output wrong values) 
*/

/* Instructions:
	- Place script in Domoticz folder /home/pi/domoticz/scripts/p1_meter/ or desired folder.
	- Make sure Curl is installed (sudo apt-get install php-curl).
	- Make sure script is executable (chmod +x filename.php).
	- All #echo's are used for debugging.
	- Put script in 'crontab -e' to run every minute. */ 
	  #Example crontab: (*/1 * * * * /home/pi/domoticz/scripts/p1_meter/electricity_data_json.php)
	
		
/* Set IP addresses and idx*/
$IPDomoticz = '192.168.0.200:8080';
$IPToon = '192.168.0.11';
$idx = 26;

/* read electricity value from Domoticz */
$json_string = file_get_contents("http://$IPDomoticz/json.htm?type=devices&rid=$idx");
$parsed_json = json_decode($json_string, true);
$parsed_json = $parsed_json['result'][0];
$ElecProductionCounterDomoticz = $parsed_json['Data']*1000;
echo "Electricity Production Counter Domoticz = ";
echo $ElecProductionCounterDomoticz;
echo " Wh";
echo "\n";

/* start of the total  Energy counter import */
$file_string_ElecProductionCounter = file_get_contents("http://$IPToon/hdrv_zwave?action=getDevices.json");
$parsed_json_ElecProductionCounter = json_decode($file_string_ElecProductionCounter, true);

/* start of current Energy Production import */
$file_string_ElecProduction = file_get_contents("http://$IPToon/happ_pwrusage?action=GetCurrentUsage");
$parsed_json_ElecProduction = json_decode($file_string_ElecProduction, true);

/* extract counter normal tariff and low tariff and add them together */
$ElecProductionCounterNT = $parsed_json_ElecProductionCounter['dev_3.4']['CurrentElectricityQuantity']; #normal tariff
$ElecProductionCounterLT = $parsed_json_ElecProductionCounter['dev_3.6']['CurrentElectricityQuantity']; #low tariff
$ElecProductionCounterToon = ($ElecProductionCounterNT + $ElecProductionCounterLT);
echo "Electricity Production Counter Toon = ";
echo $ElecProductionCounterToon;
echo " Wh";
echo "\n";

/* extract the current powerProduction */
$ElecProductionToon=$parsed_json_ElecProduction['powerProduction']['value'];
echo "Electricity Production Toon = ";
echo $ElecProductionToon;
echo " Watt";
echo "\n";

/* write new value to Domoticz */
if ($ElecProductionCounterDomoticz == 0){ #this is for the first run only, when the idx is still empty.
	$WriteInitValue = curl_init("http://$IPDomoticz/json.htm?type=command&param=udevice&idx=$idx&nvalue=0&svalue=$ElecProductionToon;$ElecProductionCounterToon");
	curl_exec($WriteInitValue);
	}
	else if ($ElecProductionCounterToon < $ElecProductionCounterDomoticz){ 
		echo "Toon value incorrect, do nothing \n";
	}
	else if ($ElecProductionCounterToon >= $ElecProductionCounterDomoticz){
		$WriteValue = curl_init("http://$IPDomoticz/json.htm?type=command&param=udevice&idx=$idx&nvalue=0&svalue=$ElecProductionToon;$ElecProductionCounterToon");
		echo "\n";
		echo "Write new value \n";
		curl_exec($WriteValue);
	}
	else {
		echo "Domoticz value incorrect, do nothing \n";
	}

?>
