#!/usr/bin/php
<?php

/* Version 1.0 written by Ierlandfan */
/* Version 1.0 modified by DennisD */
/* Version 2.0 rewritten by FunFair */
/* 19-10-2017 */

/* 
	Changelog Version 2.1
	- Removed the compare to previous value, so it will update every minute.

	Changelog Version 2.0:																		
	- Rewrite from version 1.0																	
	- Define IP adresses and idx value at start													
	- Check if Toon value is higher than Domoticz Value. (In case connection is lost with meteradapter, Toon will output wrong values) 
*/

/* Instructions:
	- Place script in Domoticz folder /home/pi/domoticz/scripts/p1_meter/ or desired folder.
	- Make sure Curl is installed (sudo apt-get install php-curl).
	- Make sure script is executable (chmod +x filename.php).
	- All echo's are used for debugging.
	- Put script in 'crontab -e' to run every minute. */ 
	  #Example crontab: (*/1 * * * * /home/pi/domoticz/scripts/p1_meter/gas_data_json.php)
	
		
/* Set IP addresses and idx*/
$IPDomoticz = '192.168.0.200:8080';
$IPToon = '192.168.0.11';
$idx = 24;

/* read Gasmeter value from Domoticz */
$json_string = file_get_contents("http://$IPDomoticz/json.htm?type=devices&rid=$idx");
$parsed_json = json_decode($json_string, true);
$parsed_json = $parsed_json['result'][0];
$GasValueDomoticz = $parsed_json['Counter']*1000; #value Domoticz is in m3, convert to liters.
echo "Gas Value Domoticz = ";
echo $GasValueDomoticz;
echo " liters";
echo "\n";

/* read Gasmeter Value from Toon */
$file_string_gas = file_get_contents("http://$IPToon/hdrv_zwave?action=getDevices.json");
$parsed_json = json_decode($file_string_gas, true);
$GasValueToon= $parsed_json['dev_3.1']['CurrentGasQuantity']; #value Toon is in liters.
echo "Gas Value Toon = ";
echo $GasValueToon;
echo " liters";
echo "\n";
echo "\n";

/* write new value to Domoticz */
if ($GasValueDomoticz == 0){ #this is for the first run only, when the idx is still empty.
	$WriteInitValue = curl_init("http://$IPDomoticz/json.htm?type=command&param=udevice&idx=$idx&nvalue=0&svalue=$GasValueToon");
	curl_exec($WriteInitValue);
	}
	else if ($GasValueToon > $GasValueDomoticz+1000){ #1000 liters in 1 hour difference is an unrealistic increase.
		echo "Toon value incorrect, do nothing \n";
	}
	else if ($GasValueToon >= $GasValueDomoticz){
		$WriteValue = curl_init("http://$IPDomoticz/json.htm?type=command&param=udevice&idx=$idx&nvalue=0&svalue=$GasValueToon");
		echo "\n";
		echo "Write new value \n";
		curl_exec($WriteValue);
	}
	else {
		echo "Domoticz value incorrect, do nothing \n";
	}
?>
