#!/usr/bin/php
<?php

/* Version 1.0 written by Ierlandfan */
/* Version 1.0 modified by DennisD */
/* Version 2.0 rewritten by FunFair */
/* Version 2.1 update by FunFair */
/* 24-10-2017 */

/* 
	Changelog Version 2.2:
	- Corrected Low and Normal tariff. They were reversed.
	
	Changelog Version 2.1:																		
	- Implemented production counters for P1 meter.
	- Removed the compare to previous value, so it will update every minute.

	Changelog Version 2.0:																		
	- Rewrite from version 1.0																	
	- Define IP adresses and idx value at start													
	- Check if Toon value is lower than Domoticz Value. (In case connection is lost with meteradapter, Toon will output wrong values.) */

/* Instructions:
	- Create a virtual P1 meter in Domoticz and write down idx value.
	- Place script in Domoticz folder /home/pi/domoticz/scripts/p1_meter/ or desired folder.
	- Set IP numbers and idx values below.
	- Make sure Curl is installed (sudo apt-get install php-curl).
	- Make sure script is executable (chmod +x filename.php).
	- All echo's are used for debugging.
	- Put script in 'crontab -e' to run every minute. */ 
	  #Example crontab: (*/1 * * * * /home/pi/domoticz/scripts/p1_meter/p1_meter_data_json.php)
	
		
/* Set IP addresses and idx*/
$IPDomoticz = '192.168.0.200:8080';
$IPToon = '192.168.0.11';
$idx = 26;

/* read electricity value from Domoticz */
$json_string = file_get_contents("http://$IPDomoticz/json.htm?type=devices&rid=$idx");
$parsed_json = json_decode($json_string, true);
$parsed_json = $parsed_json['result'][0];
$ElecUsageCounterDomoticz = $parsed_json['Counter']*1000;
$ElecProductionCounterDomoticz = $parsed_json['CounterDeliv']*1000;
echo "Electricity Usage Counter Domoticz = ";
echo $ElecUsageCounterDomoticz;
echo " Wh";
echo "\n";
echo "Electricity Production Counter Domoticz = ";
echo $ElecProductionCounterDomoticz;
echo " Wh";
echo "\n";
echo "\n";

/* start of the total Energy Usage counter import */
$file_string_ElecUsageCounter = file_get_contents("http://$IPToon/hdrv_zwave?action=getDevices.json");
$parsed_json_ElecCounter = json_decode($file_string_ElecUsageCounter, true);

/* start of current Energy Usage import */
$file_string_ElecUsage = file_get_contents("http://$IPToon/happ_pwrusage?action=GetCurrentUsage");
$parsed_json_ElecUsage = json_decode($file_string_ElecUsage, true);

/* start of the total Energy Production counter import */
$file_string_ElecProductionCounter = file_get_contents("http://$IPToon/hdrv_zwave?action=getDevices.json");
$parsed_json_ElecProductionCounter = json_decode($file_string_ElecProductionCounter, true);

/* start of current Energy Production import */
$file_string_ElecProduction = file_get_contents("http://$IPToon/happ_pwrusage?action=GetCurrentUsage");
$parsed_json_ElecProduction = json_decode($file_string_ElecProduction, true);

/* extract counter normal tariff and low tariff and add them together */
$ElecUsageCounterNT = $parsed_json_ElecCounter['dev_3.3']['CurrentElectricityQuantity']; #normal tariff
$ElecUsageCounterLT = $parsed_json_ElecCounter['dev_3.5']['CurrentElectricityQuantity']; #low tariff
$ElecUsageCounterToon = $ElecUsageCounterNT + $ElecUsageCounterLT;
$ElecProductionCounterNT = $parsed_json_ElecProductionCounter['dev_3.4']['CurrentElectricityQuantity']; #normal tariff
$ElecProductionCounterLT = $parsed_json_ElecProductionCounter['dev_3.6']['CurrentElectricityQuantity']; #low tariff
$ElecProductionCounterToon = $ElecProductionCounterNT + $ElecProductionCounterLT;
echo "Electricity Counter Toon Low Tariff = ";
echo $ElecUsageCounterLT;
echo " Wh";
echo "\n";

echo "Electricity Counter Toon Normal Tariff = ";
echo $ElecUsageCounterNT;
echo " Wh";
echo "\n";

echo "Electricity Counter Toon Total = ";
echo $ElecUsageCounterToon;
echo " Wh";
echo "\n";
echo "\n";

echo "Electricity Production Counter Toon Low Tariff = ";
echo $ElecProductionCounterLT;
echo " Wh";
echo "\n";

echo "Electricity Production Counter Toon Normal Tariff = ";
echo $ElecProductionCounterNT;
echo " Wh";
echo "\n";

echo "Electricity Production Counter Toon Total = ";
echo $ElecProductionCounterToon;
echo " Wh";
echo "\n";
echo "\n";

/* extract the current powerusage */
$ElecUsageToon=$parsed_json_ElecUsage['powerUsage']['value'];
echo "Electricity Usage Toon = ";
echo $ElecUsageToon;
echo " Watt";
echo "\n";

/* extract the current powerProduction */
$ElecProductionToon=$parsed_json_ElecProduction['powerProduction']['value'];
echo "Electricity Production Toon = ";
echo $ElecProductionToon;
echo " Watt";
echo "\n";


/* write new value to Domoticz	*/
if ($ElecUsageCounterDomoticz == 0){ #this is for the first run only, when the idx is still empty.
	$WriteInitValue = curl_init("http://$IPDomoticz/json.htm?type=command&param=udevice&idx=$idx&nvalue=0&svalue=$ElecUsageCounterLT;$ElecUsageCounterNT;$ElecProductionCounterLT;$ElecProductionCounterNT;$ElecUsageToon;$ElecProductionToon;");
		curl_exec($WriteInitValue);
	}
	else if ($ElecUsageCounterToon < $ElecUsageCounterDomoticz){ 
		echo "Toon value incorrect, do nothing \n";
	}
	else if ($ElecUsageCounterToon >= $ElecUsageCounterDomoticz){
		$WriteValue = curl_init("http://$IPDomoticz/json.htm?type=command&param=udevice&idx=$idx&nvalue=0&svalue=$ElecUsageCounterLT;$ElecUsageCounterNT;$ElecProductionCounterLT;$ElecProductionCounterNT;$ElecUsageToon;$ElecProductionToon;");
		echo "\n";
		echo "Write new value \n";
		curl_exec($WriteValue);
	}
	else {
		echo "Domoticz value incorrect, do nothing \n";
	}
?>
